'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.RequestError = exports.RequestFailure = exports.RequestSuccess = exports.RequestStart = exports.RequestInit = exports.RenderIf = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _States = require('./States');

var STATE = _interopRequireWildcard(_States);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RenderIf = exports.RenderIf = function (_React$Component) {
    (0, _inherits3.default)(RenderIf, _React$Component);

    function RenderIf() {
        (0, _classCallCheck3.default)(this, RenderIf);
        return (0, _possibleConstructorReturn3.default)(this, (RenderIf.__proto__ || (0, _getPrototypeOf2.default)(RenderIf)).apply(this, arguments));
    }

    (0, _createClass3.default)(RenderIf, [{
        key: 'render',
        value: function render() {
            if (this.props.tag && this.context.tag !== this.props.tag) {
                return null;
            }

            if (this.props.stateIn.indexOf(this.context.status) === -1) {
                return null;
            }

            var children = this.props.children;

            (0, _invariant2.default)(children || _react2.default.Children.count(children) === 1, 'A <RenderIf> may have only one child element');

            return children ? _react2.default.Children.only(children) : null;
        }
    }]);
    return RenderIf;
}(_react2.default.Component);

RenderIf.contextTypes = {
    status: _propTypes2.default.oneOf(STATE.ALL),
    response: _propTypes2.default.object,
    error: _propTypes2.default.object,
    tag: _propTypes2.default.string
};

RenderIf.propTypes = {
    stateIn: _propTypes2.default.array.isRequired
};

// just for backward compatibility until the next version
// can't change the production apps with immediately :)
var RequestInit = exports.RequestInit = function RequestInit(props) {
    return _react2.default.createElement(RenderIf, (0, _extends3.default)({ stateIn: [STATE.INIT] }, props));
};

var RequestStart = exports.RequestStart = function RequestStart(props) {
    return _react2.default.createElement(RenderIf, (0, _extends3.default)({ stateIn: [STATE.START] }, props));
};

var RequestSuccess = exports.RequestSuccess = function RequestSuccess(props) {
    return _react2.default.createElement(RenderIf, (0, _extends3.default)({ stateIn: [STATE.SUCCESS] }, props));
};

var RequestFailure = exports.RequestFailure = function RequestFailure(props) {
    return _react2.default.createElement(RenderIf, (0, _extends3.default)({ stateIn: [STATE.FAILURE] }, props));
};

var RequestError = exports.RequestError = function RequestError(props) {
    return _react2.default.createElement(RenderIf, (0, _extends3.default)({ stateIn: [STATE.ERROR] }, props));
};